<template>
  <a-table
    :columns="columns"
    :data-source="data"
    bordered
    style="width: 100%"
    :scroll="{ x: '2000' }" />
</template>

<script lang="ts">
  import { defineComponent, watch, inject, ref, onMounted } from 'vue';
  import type { TableColumnType } from 'ant-design-vue';

  export default defineComponent({
    name: 'EnvironmentTable',
    setup() {
      let data = ref<any[]>([]);
      let columns = ref<TableColumnType[]>([]);

      interface PageData {
        // 图表 表格数据
        graphTableList: any[];
        // 图表 表格表头
        graphTableColumns: any[];
        // 图表 图表数据
        graphGraphList: any[];
        // 分析 表格数据
        analysisTableList: any[];
        // 分析 图表数据
        analysisGraphList: any[];
      }
      const pageData = inject<PageData>('pageData');

      if (!pageData) {
        throw new Error('pageData is not provided');
      }
      // 监听 pageData 的变化
      watch(
        () => pageData as PageData,
        (_newValue, _oldValue) => {
          // data.value = pageData.graphTableList;

          // let columnA: any[] = [...column];
          // columnA.push(...pageData.graphTableColumns);
          // columns.value = columnA;
          // // pageData.graphList;
          // // 执行你的逻辑代码
          init();
        },
        { deep: true },
      );

      const getRowSpan = (dataIndex: string, record: any, data: any, dependents: string[] = []) => {
        let rowSpan = 1;
        for (let i = data.indexOf(record) + 1; i < data.length; i++) {
          let shouldMerge = true;
          for (const dependent of dependents) {
            if (data[i][dependent] !== record[dependent]) {
              shouldMerge = false;
              break;
            }
          }
          if (shouldMerge && data[i][dataIndex] === record[dataIndex]) {
            rowSpan++;
          } else {
            break;
          }
        }
        return rowSpan;
      };

      const column: TableColumnType[] = [
        {
          title: '设备/组名',
          dataIndex: 'deviceName',
          customCell: (record, rowIndex) => {
            if (rowIndex == undefined) {
              return {
                rowSpan: 0,
                colSpan: 0,
              };
            }
            const rowSpan = getRowSpan('deviceName', record, data.value);
            if (rowIndex != 0 && data.value[rowIndex - 1].deviceName == record.deviceName) {
              return {
                rowSpan: 0,
                colSpan: 0,
              };
            }
            return {
              rowSpan: rowSpan,
            };
          },
        },
        {
          title: '参数名称',
          dataIndex: 'selectedValueName',
          customCell: (record, rowIndex) => {
            if (rowIndex == undefined) {
              return {
                rowSpan: 0,
                colSpan: 0,
              };
            }
            const rowSpan = getRowSpan('selectedValueName', record, data.value, ['deviceName']);
            if (rowIndex != 0 && data.value[rowIndex - 1].deviceName == record.deviceName) {
              return {
                rowSpan: 0,
                colSpan: 0,
              };
            }
            return {
              rowSpan: rowSpan,
            };
          },
        },
      ];

      const init = () => {
        data.value = pageData.graphTableList;

        let columnA: any[] = [...column];
        let columnB: any[] = [];
        pageData.graphTableColumns.forEach((item) => {
          columnB.push({ title: item, dataIndex: item });
        });
        columnA.push(...columnB);
        columns.value = columnA;
      };
      onMounted(() => {
        init();
        // data.value = pageData.graphTableList;
        // let columnA: any[] = [...column];
        // columnA.push(...pageData.graphTableColumns);
        // columns.value = columnA;
        // index.value = 0;
      });
      return {
        data,
        column,
        columns,
      };
    },
  });
</script>

<style lang="less" scoped></style>
